  t3 = cos(phi);
  t4 = cy-qy;
  t5 = sin(phi);
  t6 = cx-qx;
  t9 = t3*t6;
  t10 = t4*t5;
  t2 = t9-t10;
  t12 = t3*t4;
  t13 = t5*t6;
  t7 = t12+t13;
  t8 = 1.0/(a*a);
  t11 = 1.0/(b*b);
  t14 = px*t3;
  t15 = t14-py*t5;
  t16 = py*t3;
  t17 = px*t5;
  t18 = t16+t17;
  t0 = [(t2*t2)*t8+(t7*t7)*t11-1.0,t2*t8*t15*-2.0-t7*t11*t18*2.0,t8*(t15*t15)+t11*(t18*t18)];
